	module diagnbr

	use dparlib

	use globals

	use breakup

	implicit none

	private
	public diagnbrset

        contains

	subroutine diagnbrset(pblock, tree, cathode, intnbrs)

        implicit none
	integer :: m, n
	integer, dimension(1:2,1:3) :: pblock


	logical, dimension (  	pblock(1,1):pblock(2,1),   &
				pblock(1,2):pblock(2,2),   &
				pblock(1,3):pblock(2,3) ),  intent(in) ::  &
		tree, cathode

		!! intnbrs records the index for each (edge or diagonal)
		!! path direction, for later reference. 


	integer, dimension(     pblock(1,1):pblock(2,1),   &
				pblock(1,2):pblock(2,2),   &
				pblock(1,3):pblock(2,3) ), intent(out) ::  &
		intnbrs

	logical, dimension (  	pblock(1,1):pblock(2,1),   &
				pblock(1,2):pblock(2,2),   &
				pblock(1,3):pblock(2,3) ) ::  &
			edge, op, dm	

		!! These are variable arrays to describe diagonals	

		!! By a "tree" of dp_cshifts, we develop the
		!! face- and body-diagonals, using "where" assignments
		!! To eliminate redundancy, the 8 body-diagonals are done
		!! first, then over-written by the face-diags and edges.

				!! Body-diagonals
		intnbrs = 0
		edge = .false.
		edge = dp_cshift(tree, +1, 1)
			op = .false.
			op = dp_cshift(edge, +1, 2)
				dm = .false.
				dm = dp_cshift(op, +1, 3)
				where(dm) intnbrs = 19
				dm = .false.
				dm = dp_cshift(op, -1, 3)
				where(dm) intnbrs = 20
			op = .false.
			op = dp_cshift(edge, -1, 2)
				dm = .false.
				dm = dp_cshift(op, +1, 3)
				where(dm) intnbrs = 21
				dm = .false.
				dm = dp_cshift(op, -1, 3)
				where(dm) intnbrs = 22
		edge = .false.
		edge = dp_cshift(tree, -1,1)
			op = .false.
			op = dp_cshift(edge, +1, 3)
				dm = .false.
				dm = dp_cshift(op, +1, 2)
				where(dm) intnbrs = 23
				dm = .false.
				dm = dp_cshift(op, -1, 2)
				where(dm) intnbrs = 24
			op = .false.
			op = dp_cshift(edge, -1, 3)
				dm = .false.
				dm = dp_cshift(op, +1, 2)
				where(dm) intnbrs = 25
				dm = .false.
				dm = dp_cshift(op, -1, 2)
				where(dm) intnbrs = 26

!	print *, 'body-diagonals assigned on  ', rank

				!! Face-diagonals

		edge = .false.
		edge = dp_cshift(tree, +1, 1)
			op = .false.
			op = dp_cshift(edge, +1, 2)
			where(op) intnbrs = 7
			op = .false.
			op = dp_cshift(edge, -1, 2)
			where(op) intnbrs = 8
		edge = .false.
		edge = dp_cshift(tree, -1, 1)
			op = .false.
			op = dp_cshift(edge, +1, 3)
			where(op) intnbrs = 9
			op = .false.
			op = dp_cshift(edge, -1, 3)
			where(op) intnbrs = 10
		edge = .false.
		edge = dp_cshift(tree, +1, 2)
			op = .false.
			op = dp_cshift(edge, +1, 3)
			where(op) intnbrs = 11
			op = .false.
			op = dp_cshift(edge, -1, 3)
			where(op) intnbrs = 12
		edge = .false.
		edge = dp_cshift(tree, -1, 2)
			op = .false.
			op = dp_cshift(edge, +1, 3)
			where(op) intnbrs = 13
			op = .false.
			op = dp_cshift(edge, -1, 3)
			where(op) intnbrs = 14
   		edge =  .false.
		edge = dp_cshift(tree, +1, 3)
			op = .false.
			op = dp_cshift(edge, +1, 1)
			where(op) intnbrs = 15
			op = .false.
   			op = dp_cshift(edge, -1, 1)
			where(op) intnbrs = 16
		edge = .false.
		edge = dp_cshift(tree, -1, 3)
			op = .false.
  			op = dp_cshift(edge, +1, 1)
			where(op) intnbrs = 17
			op = .false.
			op = dp_cshift(edge, -1, 1)
			where(op) intnbrs = 18

!		print *, 'face-diagonals assigned on  ', rank

				!! Edges


		edge = .false.
		edge = dp_cshift(tree, +1, 1)
		where(edge) intnbrs = 1
		edge = .false.
		edge = dp_cshift(tree, -1, 1)
		where(edge) intnbrs = 2
		edge = .false.
		edge = dp_cshift(tree, +1, 2)
		where(edge) intnbrs = 3
		edge = .false.
		edge = dp_cshift(tree, -1, 2)
		where(edge) intnbrs =4
		edge = .false.
		edge = dp_cshift(tree, +1, 3)
		where(edge) intnbrs = 5
		edge = .false.
		edge = dp_cshift(tree, -1, 3)
		where(edge) intnbrs = 6

				!! Eliminate overlaps

		where(tree .or. cathode) intnbrs = 0		

!		print *, 'intnbrs completed on ', rank

        end subroutine diagnbrset

        end module diagnbr 
