	module breakup

	use globals

	implicit none

	private

	public alloc



			
        contains

	subroutine alloc     ! Receives pblock and allocates large arrays
                             ! rank is understood and will tacitly determine
                             ! the pblock elements. Assigns red and blk arrays
			     ! within the bounds of the single block.	

	use dparlib

	use globals

       integer,dimension(:,:,:), allocatable :: rws, cls, dks, rcl
       integer :: t,num
       integer i, j, k
       character(len = (1 + pblock(2,2) - pblock(2,1))) :: line
       integer :: l1, u1, l2, u2, l3, u3



		l1 = pblock(1,1)
		u1 = pblock(2,1)
		l2 = pblock(1,2)
		u2 = pblock(2,2)
		l3 = pblock(1,3)
		u3 = pblock(2,3)



		allocate(phi( l1:u1, l2:u2, l3:u3))
		allocate(tree( l1:u1, l2:u2, l3:u3))
    		allocate(nbrs( l1:u1, l2:u2, l3:u3))
		allocate(cathode( l1:u1, l2:u2, l3:u3))
		allocate(red( l1:u1, l2:u2, l3:u3))
		allocate(blk( l1:u1, l2:u2, l3:u3))

		allocate(rws( l1:u1, l2:u2, l3:u3))
		allocate(cls( l1:u1, l2:u2, l3:u3))
		allocate(dks( l1:u1, l2:u2, l3:u3))
		allocate(rcl( l1:u1, l2:u2, l3:u3))

		allocate(fin((u1-1):(u1-1),l2:u2,l3:u3))


                !! JGH: initialization added 12/15/97
                phi = 0;
                tree = .false.
                nbrs = .false.
                cathode = .false.
                red = .false.
                blk = .false.
                rws = 0
                cls = 0
                dks = 0
                rcl = 0
                fin = .false.

	! assign red and black subgrids

         do i = l1, u1 
            rws(i,:,:) = i              !  assign rws
         end do

         do j = l2, u2 
            cls(:,j,:) = j              !  assign cls
         end do

         do k = l3, u3 
            dks(:,:,k) = k              !  assign dks
         end do

         rcl = rws + cls + dks
        
            do i = l1, u1
                do j = l2, u2 
                    do k = l3, u3 

        !            print *, rcl(i,j, k)

                    num = mod(rcl(i,j,k), 2)

        !            print *, num      

                      if(num .eq. 1) then 
                            red(i, j, k) = .true.
                      else
                            red(i, j, k) = .false.
                      end if

                  end do
              end do 
            end do
        
	  blk = .not. red
   

		print *, 'Allocation complete on ', rank
	




	deallocate (rws)
	deallocate (cls)
	deallocate (dks)
	deallocate (rcl)





	end subroutine alloc

	end module breakup
