     module globals

	
      !! use dparlib
   
        implicit none

	!! Dimensions of the global data array
	integer :: aglob, bglob, cglob

	!! The location of the anode in the global data array
	integer :: global_anode_bounds(2,3)

	integer TOTAL_PROCS
	integer, parameter :: MAX_PROCS = 32

	!! Parallel subdivision:  These are the dimensions of
	!! the process array.  These are determined at run time.
	integer :: N_PROC_ROWS 
	integer :: N_PROC_COLS
	integer :: N_PROC_DKS

	!! Note that the product of the dimensions of the process array
	!! must equal TOTAL_PROCS, and the dimensions of the global data
	!! array must be divisible by the process array dimensions in 
	!! the current implementation.



	integer :: rank


	integer, dimension(1:3) :: proc_coords
 	integer, dimension(1:3) :: pblk_size

	!! The upper and lower bounds of the local array in each of the
	!! three dimensions.
	integer, dimension(1:2,1:3) :: pblock


	integer,parameter :: r8 = selected_real_kind(8)  ! request r8
	real(kind = r8), dimension(:,:,:), allocatable :: phi
	logical, dimension(:,:,:), allocatable :: tree
	logical, dimension(:,:,:), allocatable :: nbrs
	logical, dimension(:,:,:), allocatable :: cathode
	logical, dimension(:,:,:), allocatable :: red, blk
        logical, dimension(:,:,:), allocatable :: fin      ! Indicator for completion of run



     contains



	subroutine user_query(seedvec)
	integer, intent(out) :: seedvec(:)


!       NOTE: change the following list at start of each run, then recompile.

	integer, dimension(MAX_PROCS) :: local_seedvec =   &
			
                         (/ 71, 19, 5, 43, 73, 81, 65, 49, 17, &
                              47, 3, 13, 19, 25, 83, 31, 51, 41,     &
				   37, 59, 61, 91, 63, 21, 77, 95, 15,  &
                                        87, 43, 99, 35, 53  /) 




!       Set seedvec according to the first section of local_seedvec.
!       Change local_seedvec to seed the random numbers differently.
!	First check that the length of seedvec is not greater than
! 	the length of local_seedvec.

	if (size(seedvec) .gt. size(local_seedvec))then
		print *, "ERROR: size of seedvec is greater than ", &
			size(local_seedvec)
		stop
	endif

!	Now set the values in seedvec
	seedvec = local_seedvec(1:size(seedvec))

	end subroutine user_query


     end module globals
