	module nbr

	use dparlib

	use globals

	use breakup

	implicit none

	private
	public nbrset


        contains

	subroutine nbrset(pblock, tree, cathode, nbrs)

        implicit none
	integer :: m, n
	integer, dimension(1:2,1:3) :: pblock


	logical, dimension (  	pblock(1,1):pblock(2,1),   &
				pblock(1,2):pblock(2,2),   &
				pblock(1,3):pblock(2,3) ),  intent(in) ::  &
		tree, cathode

	logical, dimension (  	pblock(1,1):pblock(2,1),   &
				pblock(1,2):pblock(2,2),   &
				pblock(1,3):pblock(2,3) ),  intent(out) :: nbrs


	logical, dimension (  	pblock(1,1):pblock(2,1),   &
				pblock(1,2):pblock(2,2),   &
				pblock(1,3):pblock(2,3) ) ::  &
		trxup, trxdn, tryup, trydn, trzup, trzdn



	   nbrs = .false.

           trxup = dp_cshift(tree, +1, 2)

           trxdn = dp_cshift(tree, -1, 2)

           tryup = dp_cshift(tree, +1, 1)

           trydn = dp_cshift(tree, -1, 1)

           trzup = dp_cshift(tree, +1, 3)

           trzdn = dp_cshift(tree, -1, 3)
 
	where(trxup .or. trxdn .or. tryup .or. trydn .or. trzup .or. trzdn) nbrs = .true.
               where(tree .or. cathode) nbrs = .false.
   
          ! The subroutine shifts the tree right and left one step in the x-dimension,
	   ! and one step in the positive and negative y-directions, to find the array of its neighbors,
	   ! which are candidates for discharge under statcomp routine.

        end subroutine nbrset

        end module nbr 
